unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables, ComCtrls, Grids, DBGrids
  , DBTreeView, ImgList;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    Query1: TQuery;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    Memo1: TMemo;
    Memo2: TMemo;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  with TDBTreeView.Create(Self) do begin
     Parent := TabSheet1;
     Width := 145;
     Height := 125;
     HideSelection := False;
     DataSource := DataSource1;
     Images := ImageList1;
     FieldString := '0;1;2';
  end;
  with TDBTreeView.Create(Self) do begin
     Parent := TabSheet2;
     Width := 145;
     Height := 125;
     HideSelection := False;
     DataSource := DataSource2;
     Images := ImageList1;
  end;
  with Table1 do begin
  try

  { do not delete the existing table }
  if not Exists then begin
      Active := False;
      CreateTable;
      {NB: all table parameters are set in the TTable component}
  end;

  {add records if table is empty}
  Open;
  if RecordCount = 0 then begin
     AppendRecord([11, 21, 'value1']);
     AppendRecord([11, 21, 'value2']);
     AppendRecord([11, 22, 'value3']);
     AppendRecord([11, 22, 'value4']);
     AppendRecord([12, 21, 'value5']);
     AppendRecord([12, 21, 'value6']);
     AppendRecord([12, 22, 'value7']);
     AppendRecord([12, 22, 'value8']);
     AppendRecord([13, 21, 'value9']);
     AppendRecord([13, 21, 'value10']);
     AppendRecord([13, 22, 'value11']);
     AppendRecord([13, 22, 'value12']);
  end; {of if recordcount}
  Close;

  except
     on E: EDataBaseError do
         raise Exception.Create(E.Message);
  end; {of try}
  end; {of with}

  if (not Table1.Active) or (not Query1.Active) then begin
     Table1.Open;
     Query1.Open;
  end
end;

end.
